﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Dim scvHelp As ScrollView
	Dim StringUtils1 As StringUtils
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("Help")
	
	scvHelp.SetLayout(10%x, 10%y, 80%x, 80%y)
	
	Dim strHelp As StringBuilder
	strHelp.Initialize
	strHelp.Append("Main Screen" & CRLF)
	strHelp.Append("For Quick Reminder, just 'Task Setup' and 'Save'" & CRLF)
	strHelp.Append("   it will make a 30 minutes reminder." & CRLF)
	strHelp.Append("   Adjust using 'Quick time adjustment' if necessary." & CRLF)
	strHelp.Append("To edit or delete existing task," & CRLF)
	strHelp.Append("   Long click at the enable/disable cell." & CRLF)
	strHelp.Append("To show the details of notes," & CRLF)
	strHelp.Append("   Long click at the notes cell." & CRLF)
	strHelp.Append(CRLF)
	strHelp.Append("Task Tab" & CRLF)
	strHelp.Append("For Date and Interval beside 'Enbl' and 'Dsbl'" & CRLF)
	strHelp.Append("   there is an option 'Pend' = Pending." & CRLF)
	strHelp.Append("   It will be not roll-over around midnight" & CRLF)
	strHelp.Append("   so that it will still be shown on Previous" & CRLF)
	strHelp.Append("   Schedule List." & CRLF)
	strHelp.Append(CRLF)
	strHelp.Append("Task Setup screen" & CRLF)
	strHelp.Append("Date Generated" & CRLF)
	strHelp.Append("   Set one or two days is usually enough." & CRLF)
	strHelp.Append("   It will be automatic roll-over around midnight." & CRLF)
	strHelp.Append("   Set it more days only if you have plan to skip" & CRLF)
	strHelp.Append("   one or more events or you want to see a history." & CRLF)
	strHelp.Append("Intervals x times" & CRLF)
	strHelp.Append("   It will be automatic roll-over around midnight." & CRLF)
	strHelp.Append("   Disabled it in the task if not required." & CRLF)
	strHelp.Append("  Custom format:" & CRLF)
	strHelp.Append("   30m12 = 30 minutes x 12 times" & CRLF)
	strHelp.Append("    3h7 = 3 hours x 7 times" & CRLF)  
	strHelp.Append("   90d3 = 90 days x 3 times" & CRLF)
	strHelp.Append("   For more than 24 hours, the Date Generated" & CRLF)
	strHelp.Append("   	  will be set to 1 day." & CRLF)
	strHelp.Append(CRLF)
	strHelp.Append("In case the application stop functioning" & CRLF)
	strHelp.Append("due to any data changed" & CRLF)
	strHelp.Append("   Clear the data by using:" & CRLF)
	strHelp.Append("    Settings -> Application Manager ->" & CRLF)
	strHelp.Append("       NotiBell -> Clear data" & CRLF)
	strHelp.Append("   Or using any text editor, edit:" & CRLF)
	strHelp.Append("    Android/data/b4a.NotiBell/files/AlarmTask.csv" & CRLF)
	strHelp.Append("    Other files in the same directory can be deleted." & CRLF)
	
	SetText(strHelp)
	
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub SetText(txt As String)
	Dim ht As Float = 10dip	' just any arbitrary value
	Dim top As Float = 0
	
	Dim lstText As List = Common.Split(txt)
	Dim lbl(lstText.Size) As Label
	scvHelp.Panel.RemoveAllViews
	For i = 0 To lstText.size - 1
		'Log(lstText)
		lbl(i).Initialize("")
		lbl(i).Text = lstText.Get(i)
		lbl(i).TextSize = Main.TextSizeStd0*.8
		lbl(i).Gravity = Gravity.left
		lbl(i).TextColor = Colors.White
		scvHelp.Panel.AddView(lbl(i), 0, top, 100%x, ht)
		Dim lbl1 As Label = scvHelp.Panel.GetView(i)
		ht = StringUtils1.MeasureMultilineTextHeight(lbl1, lbl1.Text)
		lbl1.Height = ht
		top = top + ht
	Next
'	If top < 13%y Then
'		scvHelp.Panel.Height = 13%y
'	Else
		scvHelp.Panel.Height = top
'	End If
	
	DoEvents
		
End Sub