﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Dim intHour As Int
	Dim intMinute As Int
	
	Dim EditStatus As String
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim pnlDay As Panel
	Dim pnlOption As Panel
	Dim pnlSelection5 As Panel
	Dim pnlSelection3 As Panel
	Dim SelectionText As List
	
	Dim adp As AnotherDatePicker
	Dim whlTimeHM As ClsWheel
	Dim whlValue As ClsWheel
	Dim whlInterval As ClsWheel
	
	Dim Notes As ClsDialog
	Dim Music As ClsDialog
				
	Dim lblHour As Label
	Dim lblMinute As Label
	Dim lblAmPm As Label
	Dim lblColon As Label
	
	Dim lblSetTime As Label
	Dim lblDate As Label
	Dim lblIntv As Label
	
	Dim lblDateSlct As Label

	Dim EntryType As Int	' 0 = DayOfWeek, 1 = Date, 2 = Interval 
	
	Private StringUtils1 As StringUtils

	Dim intRowOption As Int
	
	Dim strIntervalLast As String
	Dim intAdjustLast As Int
	
	Dim cdwColor(2) As ColorDrawable 
	cdwColor(0).Initialize(Colors.green, 5dip) 
	cdwColor(1).Initialize(Colors.ARGB(255,152,251,152), 5dip)
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("TaskSetup")
	Activity.Title = "Task Setup"
		
	lblHour.textsize = 34/15 * Main.TextSizeStd0
	lblColon.textsize = 22/15 * Main.TextSizeStd0
	lblMinute.textsize = 34/15 * Main.TextSizeStd0
	lblDateSlct.textsize = Main.TextSizeStd0
	lblAmPm.textsize = 22/15 * Main.TextSizeStd0
		
	lblSetTime.textsize = Main.TextSizeStd0
	lblDate.textsize = Main.TextSizeStd0
	lblIntv.textsize = Main.TextSizeStd0
	
	lblHour.SetLayout(39%x, 0, 13%x, 8%y)
	lblColon.SetLayout(52%x, 0, 4%x, 8%y)
	lblMinute.SetLayout(56%x, 0, 13%x, 8%y)
	
	lblDateSlct.SetLayout(19%x, 0, 20%x, 8%y)
	lblAmPm.SetLayout(69%x, 0, 13%x, 7%y)
		
	pnlDay.SetLayout(19%x + 4dip,8%y,81%x-4dip,7%y)
	pnlDay.Color = Colors.LightGray
	
	Dim DayWidth As Float = (pnlDay.Width-4dip) /7.0
	Dim DayText As List
	DayText.Initialize
	DayText.Add("Mon")
	DayText.Add("Tue")
	DayText.Add("Wed")
	DayText.Add("Thu")
	DayText.Add("Fri")
	DayText.Add("Sat")
	DayText.Add("Sun")
	For I = 0 To 6  ' create 7 Label
		Dim DayLbl As Label 
		DayLbl.Initialize("DayLbl") 
		DayLbl.TextSize = Main.TextSizeStd0
		DayLbl.background = cdwColor(1)
		DayLbl.TextColor = Colors.Black
		DayLbl.Gravity = Gravity.CENTER
		DayLbl.Text = DayText.Get(I)
		DayLbl.Tag = 0
		
		pnlDay.AddView(DayLbl,4dip+I*DayWidth, 2dip, DayWidth-3dip, pnlDay.Height-4dip) 
	Next 
	'Log("pnlDay view: "  & pnlDay.NumberOfViews)
	pnlDay.Visible = True

	lblSetTime.SetLayout(80%x, pnlDay.top - pnlDay.Height - 5dip, 20%x, pnlDay.Height)
	lblDate.SetLayout(0, pnlDay.top, 19%x, pnlDay.Height)
	lblIntv.SetLayout(0, pnlDay.top - pnlDay.Height - 5dip, 19%x, pnlDay.Height)
		
	pnlOption.SetLayout(0,pnlDay.top+pnlDay.Height + 5dip,100%x,85%y)
	pnlOption.Color = Colors.lightGray
	Dim btnHeight As Int = pnlOption.Height/12
	
	Dim OptionText As List
	OptionText.Initialize
	OptionText.Add(Array As String(" Date Generated","7"," 7 days"))
	OptionText.Add(Array As String(" Intervals x times","8h2"," 8 hours x 2"))
	OptionText.Add(Array As String(" Group","1","1"))
	OptionText.Add(Array As String(" Notes",""," Notes"))
	OptionText.Add(Array As String(" Vibrate","","No"))
	OptionText.Add(Array As String(" Sound Duration","180","3 min."))
	OptionText.Add(Array As String(" Sound Type","","Music"))
	OptionText.Add(Array As String(" Sound Name","","Default"))
	OptionText.Add(Array As String(" Max Volume","40","40%"))
	OptionText.Add(Array As String(" Time to Max Volume","120","2 min."))
	OptionText.Add(Array As String(" Number of Snoozes","5","5 x"))
	OptionText.Add(Array As String(" Time between Snoozes","600","10 min."))
	
	For I = 0 To OptionText.Size - 1  ' create Label & Button
		Dim OptionText0() As String = OptionText.Get(I)
	    Dim Option As Label 
		Option.Initialize("Option") 
		Option.TextSize = Main.TextSizeStd0
		Option.TextColor = Colors.Black
		Option.Gravity = Gravity.CENTER+Gravity.LEFT
		Option.Text = OptionText0(0)
		Option.Tag = OptionText0(1)
		If I > 3 Then
			Option.Color = Colors.ARGB(255,192,192,192)
		End If
		
		Dim OptionBtn As Button 
		OptionBtn.Initialize("Btn") 
		OptionBtn.TextSize = Main.TextSizeStd0
		OptionBtn.TextColor = Colors.Black
		OptionBtn.Gravity = Gravity.CENTER+Gravity.LEFT
		OptionBtn.Text = OptionText0(2)
		OptionBtn.Tag = I
	
		pnlOption.AddView(Option, 0, I*btnHeight, 40%x, btnHeight) 
		pnlOption.AddView(OptionBtn, 40%x, I*btnHeight, 60%x, btnHeight) 
	Next 
	
	pnlSelection5.Initialize("pnlSelection5")
	pnlOption.AddView(pnlSelection5, 40%x, 0, 60%x, btnHeight)
	pnlSelection5.Color = Colors.lightGray
	Dim btnWidth As Int = pnlSelection5.Width/5
	For I = 0 To 4  ' create 5 Button
		Dim Selection As Button 
		Selection.Initialize("Selection") 
		Selection.TextSize = Main.TextSizeStd1
		Selection.TextColor = Colors.Black
		Selection.Gravity = Gravity.CENTER
		Selection.Text = ""
		Selection.Tag = ""
		pnlSelection5.AddView(Selection, I*btnWidth, 0, btnWidth, btnHeight) 
	Next
	pnlSelection5.Visible = False
	
	pnlSelection3.Initialize("pnlSelection3")
	pnlOption.AddView(pnlSelection3, 40%x, 0, 60%x, btnHeight)
	pnlSelection3.Color = Colors.lightGray
	Dim btnWidth As Int = pnlSelection3.Width/3
	For I = 0 To 2  ' create 3 Button
	    Dim Selection As Button 
		Selection.Initialize("Selection") 
		Selection.TextSize = Main.TextSizeStd1
		Selection.TextColor = Colors.Black
		Selection.Gravity = Gravity.CENTER
		Selection.Text = ""
		Selection.Tag = ""
		pnlSelection3.AddView(Selection, I*btnWidth, 0, btnWidth, btnHeight) 
	Next
	pnlSelection3.Visible = False
	
'	If Main.TimeFormat = 24 Then
'		td.Is24Hours = True
'	Else
'		td.Is24Hours = False
'	End If
'	

	' Put all the initilization on the Activity_Create!
	adp.Initialize(Me, "ADP")
	whlValue.Initialize(Me, "Days" )
	whlTimeHM.Initialize(Me, "Time")
	whlInterval.Initialize(Me, "Interval")
	Notes.Initialize(Me, "Notes")
	Music.Initialize(Me, "Music")
	
	If EditStatus = "Edit" Then
		'Log("intRowTask " & Main.intRowTask )
		Task_get_value(Main.intRowTask)
	Else
		Default_set
	End If

	' Menu 
	Activity.AddMenuItem("New","New")
	Activity.AddMenuItem("Copy","Copy")
	Activity.AddMenuItem("Save","Save")
	Activity.AddMenuItem("Save as Default","SaveDefault")
	Activity.AddMenuItem("Cancel","Cancel")
End Sub

Sub Activity_Resume
	
	' Return the result from Ringtone activity.
	' work around, any better idea?
	If BtnGet(6).Text = "Ringtone" Then
		OptionGet(7).Tag = Ringtone.rtUri
		BtnGet(7).Text = Ringtone.rtName
	End If
		
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'return true if you want to consume the event
    
	' If not done like this, when editing in edittext,
	' the keyboard backspace make the menu appeared!
	If KeyCode = KeyCodes.KEYCODE_BACK OR _
		KeyCode = KeyCodes.KEYCODE_MENU Then
		Activity.OpenMenu
	 End If
	 
	Return True
End Sub

Sub lblSetTime_Click
	If lblHour.Text = "" Then
		lblHour.Text = "8"
		lblMinute.Text = "00"
	End If
	
	whlTimeHM.AddView(Activity, "T i m e", 2, Main.TextSizeStd0 * 2, 1)
	whlTimeHM.Show2(lblHour.Text & ":" & lblMinute.Text)
	
End Sub

Sub Time_Closed (Cancelled As Boolean, Selection As String)
'	Log("Cancelled = " & Cancelled & ", Result: " & Selection)
	If Not(Cancelled) Then
		intHour = Selection.SubString2(0,2)
		intMinute = Selection.SubString2(3,5)
		lblHour.Text = intHour
		lblMinute.Text = Common.PadLeft(intMinute, "0", 2)
		If Main.TimeFormat = 12 Then
			Dim HourMeridian() As String = Common.ConvertToAmPm(intHour)
			lblHour.Text = HourMeridian(0)
			lblAmPm.Text = HourMeridian(1)
			lblAmPm.Visible = True
		End If
	End If

End Sub

#Region  Option 

Sub Btn_Click
 	Dim btn As Button 
  	btn = Sender  ' Cast the Object to Button 
  	
	' Preventing user click another button while the pnlSelection is open
	pnlSelection5.Visible = False
	pnlSelection3.Visible = False
	
	intRowOption = btn.tag
	Select intRowOption
	Case 0	' Dates Generated
		SelectionText.Initialize
		If EntryType = 0 OR EntryType = 2 Then
			SelectionText.Add(Array As String("1 day",1))
			SelectionText.Add(Array As String("2 days",2))
			SelectionText.Add(Array As String("4 days",4))
			SelectionText.Add(Array As String("7 days",7))
			SelectionText.Add(Array As String("Custom",intRowOption))
				
			Dim SelectText() As String
			For I = 0 To pnlSelection5.NumberOfViews -1
				Dim Button(pnlSelection5.NumberOfViews) As Button
				Button(I) = pnlSelection5.GetView(I)
				SelectText = SelectionText.Get(I)
				Button(I).Text = SelectText(0) 
				Button(I).Tag = SelectText(1) 
			Next
			pnlSelection5.Visible = True
			pnlSelection5.Top = btn.top
		Else
			Dim DayOfMonth As String = DateTime.GetDayOfMonth(DateTime.dateparse(lblDateSlct.Tag))
			SelectionText.Add(Array As String("Once",1))
			SelectionText.Add(Array As String("Day " & DayOfMonth & " of ea. mo.",30))
			SelectionText.Add(Array As String("Yearly",360))
			Dim SelectText() As String
			For I = 0 To pnlSelection3.NumberOfViews -1
				Dim Button(pnlSelection3.NumberOfViews) As Button
				Button(I) = pnlSelection3.GetView(I)
				SelectText = SelectionText.Get(I)
				Button(I).Text = SelectText(0) 
				Button(I).Tag = SelectText(1) 
				Button(I).Enabled = True
				If I = 1 AND DayOfMonth > 28 Then
					Button(I).Enabled = False
					ToastMessageShow("Valid only for day between 1-28",False)
				End If
			Next
			pnlSelection3.Visible = True
			pnlSelection3.Top = btn.top
		
		End If
	
	Case 1	' Intervals
		SelectionText.Initialize
		If EntryType = 1 OR EntryType = 2 Then
			Select Case EntryType 
				Case 1 
					SelectionText.Add(Array As String("-15 min.","-15"))
					SelectionText.Add(Array As String("-5 min.","-5"))
					SelectionText.Add(Array As String("+1 min.","1"))
					SelectionText.Add(Array As String("+5 min.","5"))
					SelectionText.Add(Array As String("+30 min.","30"))
				Case 2 
					SelectionText.Add(Array As String("2 h x 6","2h6"))
					SelectionText.Add(Array As String("4 h x 3","4h3"))
					SelectionText.Add(Array As String("6 h x 2","6h2"))
					SelectionText.Add(Array As String("12 h x 1","12h1"))
					SelectionText.Add(Array As String("Custom",intRowOption))
			End Select
				
			Dim SelectText() As String
			For I = 0 To pnlSelection5.NumberOfViews -1
				Dim Button(pnlSelection5.NumberOfViews) As Button
				Button(I) = pnlSelection5.GetView(I)
				SelectText = SelectionText.Get(I)
				Button(I).Text = SelectText(0) 
				Button(I).Tag = SelectText(1) 
			Next
			pnlSelection5.Visible = True
			pnlSelection5.Top = btn.top
		End If
		
	Case 2  ' Group
		SelectionText.Initialize
		SelectionText.Add(Array As String("1",1))
		SelectionText.Add(Array As String("2",2))
		SelectionText.Add(Array As String("3",3))
		SelectionText.Add(Array As String("4",4))
		SelectionText.Add(Array As String("5",5))
		Dim SelectText() As String
		For I = 0 To pnlSelection5.NumberOfViews -1
			Dim Button(pnlSelection5.NumberOfViews) As Button
			Button(I) = pnlSelection5.GetView(I)
			SelectText = SelectionText.Get(I)
			Button(I).Text = SelectText(0) 
			Button(I).Tag = SelectText(1) 
		Next
		pnlSelection5.Visible = True
		pnlSelection5.Top = btn.top
	
	Case 3	' Notes
		Notes.Title = "N o t e s"
		Notes.TextSize = Main.TextSizeStd0
		Notes.Default = OptionGet(intRowOption).Tag
		Notes.AddView(Activity, 20%x, 20%y, 60%x, 30%y,1)
		Notes.Show
				
	Case 4	' Vibrate
		SelectionText.Initialize
		SelectionText.Add(Array As String("No",0))
		SelectionText.Add(Array As String("300",300))
		SelectionText.Add(Array As String("500",500))
		SelectionText.Add(Array As String("700",700))
		SelectionText.Add(Array As String("900",900))
		Dim SelectText() As String
		For I = 0 To pnlSelection5.NumberOfViews -1
			Dim Button(pnlSelection5.NumberOfViews) As Button
			Button(I) = pnlSelection5.GetView(I)
			SelectText = SelectionText.Get(I)
			Button(I).Text = SelectText(0) 
			Button(I).Tag = SelectText(1) 
		Next
		pnlSelection5.Visible = True
		pnlSelection5.Top = btn.top
			
	Case 5	' Sound Duration
		' The time is manipulate a little bit
		' so that it will not coincide with the Time to Max Volume
		' the TTS will failed.
		SelectionText.Initialize
		SelectionText.Add(Array As String("10 sec.",10))
		SelectionText.Add(Array As String("30 sec.",30))
		SelectionText.Add(Array As String("1 min.",60))
		SelectionText.Add(Array As String("2 min.",120))
		SelectionText.Add(Array As String("3 min.",180))
		Dim SelectText() As String
		For I = 0 To pnlSelection5.NumberOfViews -1
			Dim Button(pnlSelection5.NumberOfViews) As Button
			Button(I) = pnlSelection5.GetView(I)
			SelectText = SelectionText.Get(I)
			Button(I).Text = SelectText(0) 
			Button(I).Tag = SelectText(1) 
		Next
		pnlSelection5.Visible = True
		pnlSelection5.Top = btn.top
			
	Case 6	' Sound Type
		SelectionText.Initialize
		SelectionText.Add(Array As String("SILENT","SILENT"))
		SelectionText.Add(Array As String("Ringtone","Ringtone"))
		SelectionText.Add(Array As String("Music","Music"))
		Dim SelectText() As String
		For I = 0 To pnlSelection3.NumberOfViews -1
			Dim Button(pnlSelection3.NumberOfViews) As Button
			Button(I) = pnlSelection3.GetView(I)
			SelectText = SelectionText.Get(I)
			Button(I).Text = SelectText(0) 
			Button(I).Tag = SelectText(1) 
		Next
		pnlSelection3.Visible = True
		pnlSelection3.Top = btn.top
					
	Case 7	'Ring tone
		If BtnGet(intRowOption-1).Text = "Ringtone" Then
			Ringtone.rtUri = OptionGet(intRowOption).Tag 
			StartActivity("Ringtone")
			Log("btnRingtone")			' never get to this position!
			' put it in Activity_Resume
		Else
			Music.Default = BtnGet(intRowOption).Text
			Music.AddView(Activity, 10%x, 10%y, 80%x, 60%y, 2)
			Music.Show
		End If

	Case 8	' Max Volume
		Dim x As Int = 25
		For I = 0 To pnlSelection5.NumberOfViews -1
			Dim Button(pnlSelection5.NumberOfViews) As Button
			Button(I) = pnlSelection5.GetView(I)
			Button(I).Text = x & "%"
			Button(I).Tag = x
			x = x + 15
		Next
		pnlSelection5.Visible = True
		pnlSelection5.Top = btn.top
		
	Case 9	' Time to Max Volume
		' The time is manipulate a little bit
		' so that it will not coincide with the sound duration
		' the TTS will failed.
		SelectionText.Initialize
		SelectionText.Add(Array As String("8 sec.",8))
		SelectionText.Add(Array As String("18 sec.",18))
		SelectionText.Add(Array As String("28 sec.",28))
		SelectionText.Add(Array As String("58 sec.",58))
		SelectionText.Add(Array As String("2 min.",120))
		Dim SelectText() As String
		For I = 0 To pnlSelection5.NumberOfViews -1
			Dim Button(pnlSelection5.NumberOfViews) As Button
			Button(I) = pnlSelection5.GetView(I)
			SelectText = SelectionText.Get(I)
			Button(I).Text = SelectText(0) 
			Button(I).Tag = SelectText(1) 
		Next
		pnlSelection5.Visible = True
		pnlSelection5.Top = btn.top
				
	Case 10
		SelectionText.Initialize
		SelectionText.Add(Array As String("No",0))
		SelectionText.Add(Array As String("1 x",1))
		SelectionText.Add(Array As String("3 x",3))
		SelectionText.Add(Array As String("5 x",5))
		SelectionText.Add(Array As String("7 x",7))
		Dim SelectText() As String
		For I = 0 To pnlSelection5.NumberOfViews -1
			Dim Button(pnlSelection5.NumberOfViews) As Button
			Button(I) = pnlSelection5.GetView(I)
			SelectText = SelectionText.Get(I)
			Button(I).Text = SelectText(0) 
			Button(I).Tag = SelectText(1) 
		Next
		pnlSelection5.Visible = True
		pnlSelection5.Top = btn.top
			
	Case 11
		SelectionText.Initialize
		SelectionText.Add(Array As String("2 min.",120))
		SelectionText.Add(Array As String("3 min.",180))
		SelectionText.Add(Array As String("5 min.",300))
		SelectionText.Add(Array As String("10 min.",600))
		SelectionText.Add(Array As String("15 min.",900))
		Dim SelectText() As String
		For I = 0 To pnlSelection5.NumberOfViews -1
			Dim Button(pnlSelection5.NumberOfViews) As Button
			Button(I) = pnlSelection5.GetView(I)
			SelectText = SelectionText.Get(I)
			Button(I).Text = SelectText(0) 
			Button(I).Tag = SelectText(1) 
		Next
		pnlSelection5.Visible = True
		pnlSelection5.Top = btn.top
		
	End Select

End Sub

Sub BtnGet(intRow As Int) As Button
	Dim Button As Button = pnlOption.GetView(intRow*2 + 1)
	Return Button
End Sub

Sub OptionGet(intRow As Int) As Label
	Dim Label As Label = pnlOption.GetView(intRow*2)
	Return Label
End Sub

Sub Notes_Closed (Cancelled As Boolean, Selection As String)
'	Log("Cancelled = " & Cancelled & ", Result: " & Selection)
	If Not(Cancelled) Then
		Dim value As String = Selection
		OptionGet(intRowOption).Tag = value
		' Get the first time for multiline notes
		Dim intPos As Int = value.IndexOf(CRLF)	' check for multilines text
		If intPos = -1 Then
			BtnGet(intRowOption).Text = value
		Else
			' label always multiline!
			BtnGet(intRowOption).Text = value.SubString2(0,intPos)	' display only the first line
		End If
	End If

End Sub

Sub Music_closed(Cancelled As Boolean, Selection As String)
	If Not(Cancelled) Then
		OptionGet(intRowOption).Tag = Selection
		Dim value As String = Selection
		Dim intPos As Int = value.LastIndexOf("/")	' check for filename
		' there should be always filename or emtpy!
		BtnGet(intRowOption).Text = value.SubString(intPos+1)	' display only the filename
	End If
End Sub

Sub Selection_Click
	Dim btn As Button 
  	btn = Sender  ' Cast the Object to Button 
	
	If btn.Text = "Custom" Then
		Select Case intRowOption 
			Case 0 
				If  EntryType = 0 OR EntryType = 2 Then
					whlValue.AddView(Activity, "No. of days", 1, Main.TextSizeStd0 * 2, 2)
					If OptionGet(intRowOption).Tag > 3 Then
						whlValue.Show2(OptionGet(intRowOption).Tag)
					Else
						whlValue.Show2("14")
					End If
				End If
			Case 1 
				If  EntryType = 2 Then
					whlInterval.AddView(Activity, "Interval x times", 5, Main.TextSizeStd0 * 2, 5)
					whlInterval.Show2(OptionGet(intRowOption).Tag)	
				End If
		End Select
	Else
		Select Case intRowOption 
			Case 1
				If  EntryType = 1 Then
					Dim strTime As String = Common.PadLeft(intHour, "0", 2) & ":" & Common.PadLeft(intMinute, "0", 2)
					' it is critical when the time is near midnight
					Dim NewTime As Long = DateTime.DateTimeParse(lblDateSlct.Tag, strTime & ":00") + btn.tag * 60 * 1000
					lblDateSlct.Tag = DateTime.Date(NewTime)
					lblDateSlct.Text = Common.DisplayDOWDate(lblDateSlct.Tag)
					intHour = DateTime.GetHour(NewTime)
					intMinute = DateTime.GetMinute(NewTime)
					lblHour.Text = intHour
					lblMinute.Text = Common.PadLeft(intMinute, "0", 2)
					Dim intAdjust As Int = OptionGet(intRowOption).Tag + btn.tag
					OptionGet(intRowOption).Tag = intAdjust
					BtnGet(intRowOption).Text = Common.Minutes2Str(intAdjust)
				Else If EntryType = 2 Then
					OptionGet(intRowOption).Tag = btn.tag
					BtnGet(intRowOption).Text = Common.IntxTimes_Conv(OptionGet(intRowOption).Tag)
				End If
			Case Else
				OptionGet(intRowOption).Tag = btn.tag
				BtnGet(intRowOption).Text = btn.Text
		End Select
	End If
	
	pnlSelection5.Visible = False
	pnlSelection3.Visible = False
	
End Sub

Sub Days_Closed (Cancelled As Boolean, Selection As String)
'	Log("Cancelled = " & Cancelled & ", Result: " & Selection)
	If Not(Cancelled) Then
		Dim intDays As Int = Selection
		OptionGet(intRowOption).Tag = intDays
		BtnGet(intRowOption).Text = intDays & " days"
	End If
	
End Sub

Sub Interval_Closed (Cancelled As Boolean, Selection As String)
	If Not(Cancelled) Then
		OptionGet(intRowOption).Tag = Selection
		BtnGet(intRowOption).Text = Common.IntxTimes_Conv(Selection)
		Dim intHours As Int = Common.Intxtimes_hour(Selection)
		If intHours > 24 Then
			OptionGet(intRowOption-1).Tag = 1
			BtnGet(intRowOption-1).Text = "1 day"
		End If
	End If
End Sub

#End Region

#Region  Date Selection 

Sub DayLbl_click
	EntryType = 0
	Color_setting
	
	pnlSelection5.Visible = False
	pnlSelection3.Visible = False
	
	lblDateSlct.Tag = ""
	lblDateSlct.Text = ""
	
	Dim lbl As Label 
  	lbl = Sender  ' Cast the Object to label
	DayLbl_select(lbl)
		
End Sub

Sub DayLbl_select(lbl As Label)
	
	If lbl.Tag = 0 Then
				
		lbl.Background = cdwColor(0)
		Select lbl.Text
			Case "Mon"
				lbl.Tag = 4
			Case "Tue"
				lbl.Tag = 8
			Case "Wed"
				lbl.Tag = 16
			Case "Thu"
				lbl.Tag = 32
			Case "Fri"
				lbl.Tag = 64
			Case "Sat"
				lbl.Tag = 128
			Case "Sun"
				lbl.Tag = 2
		End Select
		
		OptionGet(0).Tag = 7
		BtnGet(0).Text = OptionGet(0).Tag & " day(s)"
	Else
		lbl.Background = cdwColor(1)
		lbl.Tag = 0
	End If
	
End Sub

Sub DayGet() As Int
	Dim intTotal As Int = 0
	For I = 0 To 6
		intTotal = intTotal + pnlDay.GetView(I).tag
	Next
	Return(intTotal)

End Sub

Sub DaySet(Days As Int)
	'Log("dayset:" & Bit.AND(Days, 4))
	'Log("dayset:" & Bit.AND(Days, 16))

	If Bit.AND(Days, 4) > 0 Then
		DayLbl_select(pnlDay.GetView(0))
	End If
	If Bit.AND(Days, 8) > 0 Then
		DayLbl_select(pnlDay.GetView(1))
	End If
	If Bit.AND(Days, 16) > 0 Then
		DayLbl_select(pnlDay.GetView(2))
	End If
	If Bit.AND(Days, 32) > 0 Then
		DayLbl_select(pnlDay.GetView(3))
	End If
	If Bit.AND(Days, 64) > 0 Then
		DayLbl_select(pnlDay.GetView(4))
	End If
	If Bit.AND(Days, 128) > 0 Then
		DayLbl_select(pnlDay.GetView(5))
	End If
	If Bit.AND(Days, 2) > 0 Then
		DayLbl_select(pnlDay.GetView(6))
	End If
	
End Sub

Sub lblDate_Click
	If EntryType = 2 Then
		strIntervalLast = OptionGet(1).Tag
	End If
	
	EntryType = 1
	Color_setting
	
	pnlSelection5.Visible = False
	pnlSelection3.Visible = False
	
	lblDateSlct.Visible = True
	' Beware don't use OR and numeric???
	If OptionGet(0).Tag <> "30" Then
		If OptionGet(0).Tag <> "360" Then
			OptionGet(0).Tag = 1
			BtnGet(0).Text = "Once"
		End If
	End If
	
	OptionGet(1).Text = " Quick time adjustment"
'	If intAdjustLast = 0 Then
'		intAdjustLast = "30"
'	End If
	OptionGet(1).Tag = intAdjustLast
	BtnGet(1).Text = Common.Minutes2Str(intAdjustLast)
	
	If lblDateSlct.Tag = "" Then
		Calendar_display(DateTime.Now)
	Else
		Calendar_display(DateTime.DateParse(lblDateSlct.Tag))
	End If
	
End Sub

Sub lblIntv_Click
	If EntryType = 1 Then
		intAdjustLast = OptionGet(1).Tag 
	End If
	EntryType = 2
	Color_setting
	
	pnlSelection5.Visible = False
	pnlSelection3.Visible = False
	
	lblDateSlct.Visible = True
	BtnGet(0).Text = OptionGet(0).Tag & " day(s)"
	
	OptionGet(1).Text = " Intervals x times"
	If strIntervalLast = "" Then
		strIntervalLast = "6h2"
	End If
	OptionGet(1).Tag = strIntervalLast
	BtnGet(1).Text = Common.IntxTimes_Conv(strIntervalLast)
	
	If lblDateSlct.Tag = "" Then
		Calendar_display(DateTime.Now)
	Else
		Calendar_display(DateTime.DateParse(lblDateSlct.Tag))
	End If

End Sub

Sub Calendar_display(date As Long)
	
	' If you use the AnotherDatePicker V 1.1 original,
	' modified the below statements
	adp.PanelColor = Colors.ARGB(255,152,251,152)
	adp.BeginOnSunday = False
	adp.StartingYear = DateTime.GetYear(DateTime.Now)
	adp.EndingYear = DateTime.GetYear(DateTime.Now) + 5
	
	adp.AddView(Activity)
	adp.date = date 	' add after AddToActivity
	
	adp.Show
	
End Sub

Sub ADP_Closed (Cancelled As Boolean, Date As Long)
	'Log("Cancelled = " & Cancelled & ", Date = " & DateUtils.TicksToString(Date))
	If Not(Cancelled) Then
		lblDateSlct.tag = DateTime.Date(Date)
		lblDateSlct.Text = Common.DisplayDOWDate(lblDateSlct.tag)
	End If
	Log("No. of View: " & Activity.NumberOfViews)
End Sub

#End Region

#Region  Menu Click 

Sub new_click
	EditStatus = "New"
	' Set to default values
	Default_set
	
End Sub

Sub copy_click
	EditStatus = "New"
End Sub

Sub save_click
	' SaveTableToCSV
	'Log("Save_click:" & lblDateSlct.tag)
	If lblDateSlct.tag = "" AND DayGet = 0 Then
		Msgbox("Choose the Day of Week or Date","")
	Else
		If OptionGet(3).Tag = "" Then
			OptionGet(3).Tag = "Remind Me"
		End If
		If EditStatus = "Edit" Then
			TimeManager.ListTask.RemoveAt(Main.intRowTask)
		End If
		Dim row() As String
		row = Mapping0
		TimeManager.ListTask.Add(row)
		
		CallSub(TimeManager,"ListTask_sort")
		
		StringUtils1.SaveCSV(Main.dir, Main.FileTask, ",", TimeManager.ListTask)
		
		StartServiceAt(TimeManager, DateTime.now, True)	
		
		Activity.finish
	End If
	
End Sub

Sub savedefault_click
	' SaveTableToCSV
	Dim row() As String
	row = Mapping0
	
	Dim ListDefault As List
	ListDefault.Initialize
	ListDefault.Add(row)	
	
	StringUtils1.SaveCSV(Main.dir, Main.fileDefault, ",", ListDefault)
End Sub
	
Sub cancel_click
	Activity.finish
End Sub

Sub Default_set
	DateTime.DateFormat = "MM/dd/yyyy"

	If File.Exists(Main.dir, Main.fileDefault) Then
		Dim Listdefault As List
		Listdefault.Initialize
		Listdefault = StringUtils1.LoadCSV(Main.dir, Main.fileDefault, ",")
		strIntervalLast = "6h2"
		Dim row() As String 
		row = Listdefault.Get(0)
		Dim NextTime As Long = DateTime.Now + 30 * 60 * 1000
		row(0) = "D"
		row(1) = 1
		row(2) = DateTime.Date(NextTime)
		row(3) = DateTime.Time(NextTime)
		row(4) = 1
		row(5) = 30
			
		Mapping1(row)
	Else
		strIntervalLast = "6h2"
		' Set to the standard values
		Dim row(Main.NoOfColumns) As String
		row(0) = "D"
		row(1) = 1
		Dim NextTime As Long = DateTime.Now + 30 * 60 * 1000
		row(2) = DateTime.Date(NextTime)
		row(3) = DateTime.Time(NextTime)
		row(4) = 1
		row(5) = 30
		row(6) = 1
		row(7) = ""
		row(8) = 300
		row(9) = 60
		row(10) = "Music"
		row(11) = ""
		row(12) = 70 
		row(13) = 30
		row(14) = 3
		row(15) = 180
		
		OptionGet(1).Text = " Quick time adjustment"
		
		Mapping1(row)
				
		ToastMessageShow("User Default setting not available",False)
	End If
	
End Sub

Sub Task_get_value(intRow As Int)

	Dim row() As String
	row = TimeManager.ListTask.Get(intRow)
	Mapping1(row)
	
End Sub

#End Region
	
#Region  Mapping 

Sub Mapping0 As String()
	Dim row(Main.NoOfColumns) As String
	Select EntryType 
		Case 0 
			row(0) = "W"		' W = weekdays
			row(2) = DayGet
		Case 1
			row(0) = "D"		' D = Date
			row(2) = lblDateSlct.tag
		Case 2
			row(0) = "I"		' I = Interval
			row(2) = lblDateSlct.tag
	End Select
	row(1) = 1			' Enable
	row(3) = Common.PadLeft(intHour, "0", 2) & ":" & Common.PadLeft(intMinute, "0", 2)
	
	row(4) = OptionGet(0).tag
	row(5) = OptionGet(1).tag	'
	row(6) = OptionGet(2).tag	' group
	row(7) = OptionGet(3).tag	' Notes
	row(8) = OptionGet(4).tag
	row(9) = OptionGet(5).Tag		' Sound Duration
	row(10) = OptionGet(6).Tag			' Ring tone/Music
	row(11) = OptionGet(7).Tag		
	row(12) = OptionGet(8).tag		' Max Volume
	row(13) = OptionGet(9).tag		' Time to Max Volume
	row(14) = OptionGet(10).Tag
	row(15) = OptionGet(11).Tag		' Time between Snoozes
	
	Return row
End Sub	

Sub Mapping1(row() As String)  
	Dim value As String
	Select Case row(0)
		Case "W" 
			DaySet(row(2))
			EntryType = 0
			lblDateSlct.tag = ""
		Case "D" 
			lblDateSlct.tag = row(2)
			lblDateSlct.Text = Common.DisplayDOWDate(lblDateSlct.tag)
			EntryType = 1
		Case "I"
			lblDateSlct.tag = row(2)
			lblDateSlct.Text = Common.DisplayDOWDate(lblDateSlct.tag)
			EntryType = 2
	End Select
	Color_setting
	
	intHour = row(3).SubString2(0,2)
	intMinute = row(3).SubString2(3,5)
	lblHour.Text = intHour
	lblMinute.Text = Common.PadLeft(intMinute, "0", 2)
	If Main.TimeFormat = 12 Then
		Dim HourMeridian() As String = Common.ConvertToAmPm(intHour)
		lblHour.Text = HourMeridian(0)
		lblAmPm.Text = HourMeridian(1)
		lblAmPm.Visible = True
	End If
		
	' Start of Option
	Dim strDayWord As String = "days"
	If  row(4) = 1 Then
		strDayWord = "day"
	End If
	Select Case row(0)
		Case "W"
			OptionGet(0).Tag = row(4)
			BtnGet(0).Text = OptionGet(0).Tag & strDayWord
		Case "D" 
			OptionGet(0).Tag = row(4)
			Select Case row(4) 
				Case 1 
					BtnGet(0).Text = "Once"
				Case 30
					Dim DayOfMonth As String = DateTime.GetDayOfMonth(DateTime.dateparse(lblDateSlct.Tag))
					BtnGet(0).Text = "Day " & DayOfMonth & " of each month"
				Case 360
					BtnGet(0).Text = "Yearly"
			End Select
		Case "I"
			OptionGet(0).Tag = row(4)
			BtnGet(0).Text = OptionGet(0).Tag & strDayWord
	End Select
	
	Select Case row(0)
		Case "D"
			strIntervalLast = "6h2"
			If EditStatus = "New" Then
				OptionGet(1).Tag = 30
			Else
				OptionGet(1).Tag = 0
			End If
			OptionGet(1).Text = " Quick time adjustment"
			BtnGet(1).Text = OptionGet(1).Tag & " min."
		Case "I"
			If EditStatus = "New" Then
				intAdjustLast = 30
			Else
				intAdjustLast = 0
			End If
			OptionGet(1).Tag = row(5)
			BtnGet(1).Text = Common.IntxTimes_Conv(row(5))
		Case Else
			strIntervalLast = "6h2"
			If EditStatus = "New" Then
				intAdjustLast = 30
			Else
				intAdjustLast = 0
			End If	
		End Select
	
	OptionGet(2).Tag = row(6)
	BtnGet(2).Text = OptionGet(2).Tag
	
	OptionGet(3).Tag = row(7)
	value = OptionGet(3).tag
	' Get the first time for multiline notes
	Dim intPos As Int = value.IndexOf(CRLF)	' check for multilines text
	If intPos = -1 Then
		BtnGet(3).Text = value
	Else
		' label always multiline!
		BtnGet(3).Text = value.SubString2(0,intPos)	' display only the first line
	End If
	
	' Vibrate
	OptionGet(4).Tag = row(8)
	If row(8) > 0 Then
		BtnGet(4).Text = row(8) & " msec."
	Else
		BtnGet(4).Text = "No"
	End If
	
	' Sound Duration
	OptionGet(5).Tag = row(9)
	If row(9) >= 60 Then
		BtnGet(5).Text = (row(9)/60) & " min."
	Else
		BtnGet(5).Text = row(9) & " sec."
	End If
	
	OptionGet(6).Tag = row(10)
	BtnGet(6).Text = row(10)
	
	OptionGet(7).Tag = row(11)
	value = OptionGet(7).Tag
	If row(10) = "Ringtone" Then
		If Not(value = "") Then
			BtnGet(7).Text = Common.RingtoneName(value)
			'Log("Ringtone name: " & BtnGet(7).Text)
			' I don't like this, any alternative?
			Ringtone.rtUri = OptionGet(7).Tag
			Ringtone.rtName = BtnGet(7).Text
		Else
			BtnGet(7).Text = "Silent"
		End If
	Else
		If value = "" Then
			BtnGet(7).Text = "Default"
		Else
			Dim intPos As Int = value.LastIndexOf("/")	' check for filename
			' there should be always filename or emtpy!
			BtnGet(7).Text = value.SubString(intPos+1)	' display only the filename/ringtone
		End If
	End If
	
	OptionGet(8).tag  = row(12)
	BtnGet(8).Text = row(12) & "%"
	
	OptionGet(9).tag = row(13)
	If row(13) >= 60 Then
		BtnGet(9).Text = (row(13)/60) & " min."
	Else
		BtnGet(9).Text = row(13) & " sec."
	End If
	
	OptionGet(10).tag = row(14)
	BtnGet(10).Text = row(14) & " x"
	
	OptionGet(11).tag = row(15)
	If row(15) >= 60 Then
		BtnGet(11).Text = (row(15)/60) & " min."
	Else
		BtnGet(11).Text = row(15) & " sec."
	End If
	
End Sub

Sub Color_setting
	' Be carefull don't mixed cdwColor for different size button/label!!!
	Select Case EntryType
		Case 0 
			lblIntv.color = Colors.ARGB(255,152,251,152)
			lblIntv.TextColor = Colors.Gray
			lblDate.color = Colors.ARGB(255,152,251,152)
			lblDate.TextColor = Colors.Gray
			BtnGet(0).Enabled = True
			BtnGet(0).TextColor = Colors.black
			BtnGet(1).Enabled = False
			BtnGet(1).TextColor = Colors.gray
		Case 1
			For i = 0 To 6
				Dim lbl As Label = pnlDay.GetView(i)
				lbl.Background = cdwColor(1)
				lbl.TextColor = Colors.Gray
				lbl.Tag = 0
			Next
			lblIntv.color = Colors.ARGB(255,152,251,152)
			lblIntv.TextColor = Colors.Gray
			lblDate.color = Colors.green
			lblDate.TextColor = Colors.Black
			BtnGet(0).Enabled = True
			BtnGet(0).TextColor = Colors.Black
			BtnGet(1).Enabled = True
			BtnGet(1).TextColor = Colors.Black
		Case 2
			For i = 0 To 6
				Dim lbl As Label = pnlDay.GetView(i)
				lbl.Background = cdwColor(1)
				lbl.TextColor = Colors.Gray
				lbl.Tag = 0
			Next
			lblDate.color = Colors.ARGB(255,152,251,152)
			lblDate.TextColor = Colors.Gray
			lblIntv.color = Colors.green
			lblIntv.TextColor = Colors.black
			BtnGet(0).Enabled = True
			BtnGet(0).TextColor = Colors.black
			BtnGet(1).Enabled = True
			BtnGet(1).TextColor = Colors.black
	End Select

End Sub

#End Region

